From 45a1e625d1710201b559d215843741c977fb1428 Mon Sep 17 00:00:00 2001
From: Dan McDonald <danmcd@joyent.com>
Date: Tue, 21 Jan 2020 09:49:40 -0500
Subject: [PATCH] C. Fraire code review comments

---
 usr/src/cmd/fs.d/nfs/dtrace/nfs-time.d          | 4 ++--
 usr/src/cmd/fs.d/nfs/dtrace/nfs-trace.d         | 2 +-
 usr/src/cmd/smbsrv/dtrace/smb-trace.d           | 2 +-
 usr/src/cmd/smbsrv/dtrace/smb2-trace.d          | 2 +-
 usr/src/pkg/manifests/system-file-system-nfs.mf | 1 -
 usr/src/uts/common/Makefile.files               | 2 --
 usr/src/uts/common/fs/nfs/nfs4_common.c         | 2 +-
 usr/src/uts/common/fs/nfs/nfs4_state.c          | 7 ++++---
 usr/src/uts/common/fs/nfs/nfs_server.c          | 9 +--------
 usr/src/uts/common/fs/sharefs/sharetab.c        | 4 ++--
 usr/src/uts/common/nfs/auth.h                   | 6 +++---
 usr/src/uts/common/nfs/nfs4.h                   | 2 +-
 12 files changed, 17 insertions(+), 26 deletions(-)

diff --git a/usr/src/cmd/fs.d/nfs/dtrace/nfs-time.d b/usr/src/cmd/fs.d/nfs/dtrace/nfs-time.d
index d8302cabc1..7d7c33d153 100755
--- a/usr/src/cmd/fs.d/nfs/dtrace/nfs-time.d
+++ b/usr/src/cmd/fs.d/nfs/dtrace/nfs-time.d
@@ -16,7 +16,7 @@
  */
 
 /*
- * Quanitize the time spent in each NFSv3 andf NFSv4 operation,
+ * Quantize the time spent in each NFSv3 andf NFSv4 operation,
  * optionally for a specified client, share and zone.
  *
  * Usage: nfs-time.d [<client ip>|all [<share path>|all] [<zone id>]]]
@@ -25,7 +25,7 @@
  *
  * It is valid to specify <client ip> or <share path> as "all"
  * to quantize data for all clients and/or all shares.
- * Ommitting <zone id> will quantize data for all zones.
+ * Omitting <zone id> will quantize data for all zones.
  */
 
 #pragma D option flowindent
diff --git a/usr/src/cmd/fs.d/nfs/dtrace/nfs-trace.d b/usr/src/cmd/fs.d/nfs/dtrace/nfs-trace.d
index 46bc3a0a80..a89fed3424 100755
--- a/usr/src/cmd/fs.d/nfs/dtrace/nfs-trace.d
+++ b/usr/src/cmd/fs.d/nfs/dtrace/nfs-trace.d
@@ -25,7 +25,7 @@
  *
  * It is valid to specify <client ip> or <share path> as "all"
  * to quantize data for all clients and/or all shares.
- * Ommitting <zone id> will quantize data for all zones.
+ * Omitting <zone id> will quantize data for all zones.
  */
 
 /*
diff --git a/usr/src/cmd/smbsrv/dtrace/smb-trace.d b/usr/src/cmd/smbsrv/dtrace/smb-trace.d
index 1ed48eaf2d..40b3cba219 100644
--- a/usr/src/cmd/smbsrv/dtrace/smb-trace.d
+++ b/usr/src/cmd/smbsrv/dtrace/smb-trace.d
@@ -32,7 +32,7 @@
  *
  * It is valid to specify <client ip> or <share path> as "all" to
  * print data for all clients and/or all shares.
- * Ommitting <zone id> will print data for all zones.
+ * Omitting <zone id> will print data for all zones.
  */
 
 #pragma D option defaultargs
diff --git a/usr/src/cmd/smbsrv/dtrace/smb2-trace.d b/usr/src/cmd/smbsrv/dtrace/smb2-trace.d
index 572b09f31b..409d878dea 100644
--- a/usr/src/cmd/smbsrv/dtrace/smb2-trace.d
+++ b/usr/src/cmd/smbsrv/dtrace/smb2-trace.d
@@ -31,7 +31,7 @@
  *
  * It is valid to specify <client ip> or <share path> as "all" to
  * print data for all clients and/or all shares.
- * Ommitting <zone id> will print data for all zones.
+ * Omitting <zone id> will print data for all zones.
  */
 
 #pragma D option defaultargs
diff --git a/usr/src/pkg/manifests/system-file-system-nfs.mf b/usr/src/pkg/manifests/system-file-system-nfs.mf
index 3ad5e073da..7c4e786f97 100644
--- a/usr/src/pkg/manifests/system-file-system-nfs.mf
+++ b/usr/src/pkg/manifests/system-file-system-nfs.mf
@@ -22,7 +22,6 @@
 #
 # Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
 # Copyright 2019 OmniOS Community Edition (OmniOSce) Association.
-# Copyright 2019 Nexenta by DDN, Inc.  All rights reserved.
 #
 
 set name=pkg.fmri value=pkg:/system/file-system/nfs@$(PKGVERS)
diff --git a/usr/src/uts/common/Makefile.files b/usr/src/uts/common/Makefile.files
index 70339f00b8..59eb175515 100644
--- a/usr/src/uts/common/Makefile.files
+++ b/usr/src/uts/common/Makefile.files
@@ -28,8 +28,6 @@
 # Copyright 2019 Joyent, Inc.
 # Copyright 2016 OmniTI Computer Consulting, Inc.  All rights reserved.
 # Copyright 2016 Hans Rosenfeld <rosenfeld@grumpf.hope-2000.org>
-# Copyright 2018 Nexenta Systems, Inc.
-# Copyright 2019 Nexenta by DDN, Inc.
 #
 
 #
diff --git a/usr/src/uts/common/fs/nfs/nfs4_common.c b/usr/src/uts/common/fs/nfs/nfs4_common.c
index 333546bde1..11c6984f95 100644
--- a/usr/src/uts/common/fs/nfs/nfs4_common.c
+++ b/usr/src/uts/common/fs/nfs/nfs4_common.c
@@ -21,7 +21,7 @@
 /*
  * Copyright (c) 2003, 2010, Oracle and/or its affiliates. All rights reserved.
  *
- * Copyright 2013 Nexenta Systems, Inc.  All rights reserved.
+ * Copyright 2011, 2012 Nexenta Systems, Inc. All rights reserved.
  * Copyright 2013 Joyent, Inc. All rights reserved.
  */
 
diff --git a/usr/src/uts/common/fs/nfs/nfs4_state.c b/usr/src/uts/common/fs/nfs/nfs4_state.c
index 727c043c63..6af890191a 100644
--- a/usr/src/uts/common/fs/nfs/nfs4_state.c
+++ b/usr/src/uts/common/fs/nfs/nfs4_state.c
@@ -1155,9 +1155,10 @@ rfs4_state_g_init()
 	/*
 	 * NFSv4 server state databases
 	 *
-	 * Initilized when the module is loaded and used by NFSv4 state tables.
-	 * These kmem_cache free pools are used globally, the NFSv4 state
-	 * tables which make use of these kmem_cache free pools are per zone.
+	 * Initialized when the module is loaded and used by NFSv4 state
+	 * tables.  These kmem_cache free pools are used globally, the NFSv4
+	 * state tables which make use of these kmem_cache free pools are per
+	 * zone.
 	 *
 	 * initialize the global kmem_cache free pools which will be used by
 	 * the NFSv4 state tables.
diff --git a/usr/src/uts/common/fs/nfs/nfs_server.c b/usr/src/uts/common/fs/nfs/nfs_server.c
index 9f5c118163..2a59bb4ddc 100644
--- a/usr/src/uts/common/fs/nfs/nfs_server.c
+++ b/usr/src/uts/common/fs/nfs/nfs_server.c
@@ -32,13 +32,6 @@
  *	Use is subject to license terms.
  */
 
-/*
- * Copyright (c) 2011 Bayard G. Bell. All rights reserved.
- * Copyright (c) 2013 by Delphix. All rights reserved.
- * Copyright 2018 Nexenta Systems, Inc.
- * Copyright (c) 2017 Joyent Inc
- */
-
 #include <sys/param.h>
 #include <sys/types.h>
 #include <sys/systm.h>
@@ -2624,7 +2617,7 @@ nfs_srvfini(void)
  * objects have exactly the same lifetime.
  *
  * These objects are also kept on a list for two reasons:
- * 1: It makes finding these in  mdb _much_ easier.
+ * 1: It makes finding these in mdb _much_ easier.
  * 2: It allows operating across all zone globals for
  *    functions like nfs_auth.c:exi_cache_reclaim
  */
diff --git a/usr/src/uts/common/fs/sharefs/sharetab.c b/usr/src/uts/common/fs/sharefs/sharetab.c
index 0bb7d18488..9a95f206eb 100644
--- a/usr/src/uts/common/fs/sharefs/sharetab.c
+++ b/usr/src/uts/common/fs/sharefs/sharetab.c
@@ -220,7 +220,7 @@ sharefs_add(sharetab_globals_t *sg, share_t *sh, sharefs_lens_t *shl)
 		    strlen(sh->sh_opts) + strlen(sh->sh_descr);
 	}
 
-	/* We need to account for field seperators and the EOL */
+	/* We need to account for field separators and the EOL */
 	sh->sh_size += 5;
 
 	/* Now walk down the hash table and add the new entry */
@@ -440,7 +440,7 @@ sharefs(enum sharefs_sys_op opcode, share_t *sh_in, uint32_t iMaxLen)
 {
 	/*
 	 * If we're in the global zone PRIV_SYS_CONFIG gives us the
-	 * priviledges needed to act on sharetab. However if we're in
+	 * privileges needed to act on sharetab. However if we're in
 	 * a non-global zone PRIV_SYS_CONFIG is not allowed. To work
 	 * around this issue PRIV_SYS_NFS is used in this case.
 	 *
diff --git a/usr/src/uts/common/nfs/auth.h b/usr/src/uts/common/nfs/auth.h
index a35ad9109b..5293e3fdd1 100644
--- a/usr/src/uts/common/nfs/auth.h
+++ b/usr/src/uts/common/nfs/auth.h
@@ -20,12 +20,12 @@
  */
 
 /*
- * Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
- * Use is subject to license terms.
+ * Copyright 2014 Nexenta Systems, Inc.  All rights reserved.
  */
 
 /*
- * Copyright 2018 Nexenta Systems, Inc.
+ * Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
  */
 
 #ifndef _AUTH_H
diff --git a/usr/src/uts/common/nfs/nfs4.h b/usr/src/uts/common/nfs/nfs4.h
index 39178138e8..ce09473f95 100644
--- a/usr/src/uts/common/nfs/nfs4.h
+++ b/usr/src/uts/common/nfs/nfs4.h
@@ -124,7 +124,7 @@ typedef struct {		/* opaque entry type for later use */
 /*
  * NFSv4 server state databases
  *
- * Initilized when the module is loaded and used by NFSv4 state tables.
+ * Initialized when the module is loaded and used by NFSv4 state tables.
  * These kmem_cache free pools are used globally, the NFSv4 state tables
  * which make use of these kmem_cache free pools are per zone.
  */
-- 
2.21.0 (Apple Git-122)